%global momorel 2
%global tcpdump_version 3.9.4
%global tcpdump_dir tcpdump-%{tcpdump_version}

%global libpcap_momorel 1
%global pcap_major 0
%global pcap_minor 9
%global pcap_subminor 4
%global libpcap_ver %{pcap_major}.%{pcap_minor}.%{pcap_subminor}
%global libpcap_dir libpcap-%{libpcap_ver}

%global arpwatch_momorel 6
%global arpwatch_ver 2.1a13
%global	arpwatch_dir arpwatch-%{arpwatch_ver}

%global tcpslice_dir tcpslice

%global _vararpwatch %{_localstatedir}/arpwatch
%global PCAP_UID 77
%global PCAP_GID 77

Summary: A network traffic monitoring tool.
Name: tcpdump
Version: %{tcpdump_version}
Release: %{momorel}m
License: BSD
Group: Applications/Internet
URL: http://www.tcpdump.org/
%NoSource 0 http://www.tcpdump.org/release/%{name}-%{version}.tar.gz 4b64755bbc8ba1af49c747271a6df5b8
%NoSource 1 http://www.tcpdump.org/release/libpcap-%{libpcap_ver}.tar.gz 79025766e8027df154cb1f32de8a7974
%NoSource 2 ftp://ftp.ee.lbl.gov/arpwatch-%{arpwatch_ver}.tar.gz b9ff9739cdd2c0e9807b2d05860e4811
Source3: arpwatch.init
Source4: tcpslice-CVS.20010207.tar.gz
Source5: arpwatch.sysconfig
Source6: rpc.tar.gz

Patch5:  tcpdump-3.6.2-tcpslice-time.patch
Patch7:  tcpdump-3.9.1-redhat.patch

# tcpdump
Patch10: tcpdump-3.6.1-portnumbers.patch
Patch15: tcpdump-3.6.2-ip6opts.patch
Patch16: tcpdump-3.8.1-sctp.patch
Patch17: tcpdump-3.7.2-sctpdef.patch
Patch19: tcpdump-3.8.2-rsvp-dos.patch
Patch21: tcpdump-3.8.2-isis-dos.patch
Patch22: tcpdump-3.9.4-ring-buffers.patch
# arpwatch
Patch34: arpwatch-2.1a4-fhs.patch
Patch35: arpwatch-2.1a10-man.patch
Patch38: arpwatch-drop.patch
Patch39: arpwatch-drop-man.patch
Patch41: arpwatch-addr.patch
Patch42: arpwatch-dir-man.patch
Patch43: arpwatch-ethcodes.patch.bz2
# libpcap
Patch50: libpcap-shared.patch
Patch52: tcpdump-3.7.2-s390.patch
Patch53: libpcap-0.8.3-ppp.patch

Patch70: tcpslice-CVS.20010207-bpf.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: kernel-headers >= 2.2.0
BuildRequires: momonga-rpmmacros >= 20040310-6m
BuildPreReq: openssl-devel >= 0.9.6
BuildPreReq: glibc-devel >= 2.2.5-12k
PreReq: chkconfig shadow-utils
Requires: kernel >= 2.2.0

%description
Tcpdump is a command-line tool for monitoring network traffic.  Tcpdump
can capture and display the packet headers on a particular network
interface or on all interfaces.  Tcpdump can display all of the packet
headers, or just the ones that match particular criteria.

Install tcpdump if you need a program to monitor network traffic.

%package -n libpcap
Version: %{libpcap_ver}
Release: %{libpcap_momorel}m
Summary: A system-independent interface for user-level packet capture.
Group: Development/Libraries
Requires: kernel >= 2.2.0

%description -n libpcap
Libpcap provides a portable framework for low-level network monitoring.
Libpcap can provide network statistics collection, security monitoring
and network debugging.  Since almost every system vendor provides a
different interface for packet capture, the libpcap authors created this
system-independent API to ease in porting and to alleviate the need for
several system-dependent packet capture modules in each application.

Install libpcap if you need to do low-level network traffic monitoring on
your network.

%package -n arpwatch
Version: %{arpwatch_ver}
Release: %{arpwatch_momorel}m
Summary: Network monitoring tools for tracking IP addresses on a network.
Group: Applications/System
PreReq: chkconfig, shadow-utils

%description -n arpwatch
The arpwatch package contains arpwatch and arpsnmp.  Arpwatch and arpsnmp
are both network monitoring tools.  Both utilities monitor Ethernet or
FDDI network traffic and build databases of Ethernet/IP address pairs,
and can report certain changes via email.

Install the arpwatch package if you need networking monitoring devices
which will automatically keep traffic of the IP addresses on your
network.

%prep
%setup -q -c -a 1 -a 2 -a 4

%patch5 -p1 -b .tcpslicetime
%patch7 -p1 -b .rh

pushd %{libpcap_dir}
%patch50 -p1 -b .shared
%patch52 -p1 -b .s390
%patch53 -p0 -b .ppp
popd

pushd %{tcpdump_dir}
%patch10 -p1 -b .portnumbers
%patch15 -p1 -b .ip6opts
%patch16 -p1 -b .sctp
%patch17 -p1 -b .sctpdef
%patch19 -p1 -b .rsvp-dos
%patch21 -p1 -b .isis-dos
%patch22 -p1 -b .ring
tar xzf %{SOURCE6}
popd

pushd %{arpwatch_dir}
%patch34 -p1 -b .fhs
%patch35 -p1 -b .arpsnmpman
%patch38 -p1 -b .droproot
%patch39 -p0 -b .droprootman
%patch41 -p1 -b .mailuser
%patch42 -p1 -b .dirman
%patch43 -p1
popd

pushd %{tcpslice_dir}
%patch70 -p1 -b .bpf
popd

%build
pushd %{libpcap_dir}
unset CFLAGS
%if %{_ipv6}
%configure --enable-ipv6
%else
%configure --disable-ipv6
%endif
DEFS="-D_U_=\"\" -fPIC -DHAVE_CONFIG_H -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE"
make DEFS="$DEFS" \
    LIBMAJOR="%{pcap_major}" \
    LIBMINOR="%{pcap_minor}" \
    LIBSUBMINOR="%{pcap_subminor}"

popd

pushd %{tcpslice_dir}
%configure
make
popd

pushd %{tcpdump_dir}
unset CFLAGS
%define optflags $RPM_OPT_FLAGS -DIP_MAX_MEMBERSHIPS=20
%if %{_ipv6}
%configure --enable-ipv6  --with-user=pcap
%else
%configure --disable-ipv6  --with-user=pcap
%endif
%undefine optflags
DEFS="-D_U_=\"\" -DHAVE_CONFIG_H -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE"
make DEFS="$DEFS"
popd

pushd %{arpwatch_dir}
%configure
make ARPDIR=%{_vararpwatch}
popd

%install
rm -rf --preserve-root %{buildroot}

install -m 0755 -d %{buildroot}%{_libdir}
install -m 0755 -d %{buildroot}%{_mandir}/man{3,8}
install -m 0755 -d %{buildroot}%{_sbindir}

pushd %{libpcap_dir}
mkdir -p %{buildroot}%{_includedir}/net
make DESTDIR=%{buildroot} includedir=%{_includedir} \
     LIBMAJOR="%{pcap_major}" \
     LIBMINOR="%{pcap_minor}" \
     LIBSUBMINOR="%{pcap_subminor}" \
     install
chmod +x %{buildroot}%{_libdir}/libpcap.so.*
popd

pushd %{tcpslice_dir}
install -m755 tcpslice   %{buildroot}%{_sbindir}
install -m644 tcpslice.1 %{buildroot}%{_mandir}/man8/tcpslice.8
popd

pushd %{tcpdump_dir}
install -m755 tcpdump   %{buildroot}%{_sbindir}
install -m644 tcpdump.1 %{buildroot}%{_mandir}/man8/tcpdump.8
popd

pushd %{arpwatch_dir}
make DESTDIR=%{buildroot} install install-man
mkdir -p %{buildroot}%{_vararpwatch}
for n in arp2ethers arpfetch massagevendor massagevendor-old; do
    install -m755 $n %{buildroot}%{_vararpwatch}
done
for n in *.awk *.dat missingcodes.txt; do
    install -m644 $n %{buildroot}%{_vararpwatch}
done
( cd %{buildroot}
  mkdir -p ./etc/rc.d/init.d
  install -c -m755 $RPM_SOURCE_DIR/arpwatch.init ./etc/rc.d/init.d/arpwatch
  mkdir -p ./etc/sysconfig
  install -c -m644 $RPM_SOURCE_DIR/arpwatch.sysconfig ./etc/sysconfig/arpwatch
)
popd

%clean
rm -rf --preserve-root %{buildroot}

%pre
/usr/sbin/groupadd -g %{PCAP_GID} pcap  2> /dev/null
/usr/sbin/useradd -u %{PCAP_UID} -g %{PCAP_GID} -s /sbin/nologin -M -r \
    -d %{_vararpwatch} pcap 2> /dev/null \
    || /usr/bin/chsh pcap /sbin/nologin 2> /dev/null
exit 0

%post -n arpwatch
/sbin/chkconfig --add arpwatch

%pre -n arpwatch
/usr/sbin/groupadd -g %{PCAP_GID} pcap  2> /dev/null
/usr/sbin/useradd -u %{PCAP_UID} -g %{PCAP_GID} \
    -s /sbin/nologin -M -r -d %{_vararpwatch} pcap 2> /dev/null \
    || /usr/bin/chsh pcap /sbin/nologin 2> /dev/null
exit 0

%postun -n arpwatch
/sbin/service arpwatch condrestart >/dev/null 2>&1 || :

%preun -n arpwatch
if [ "$1" = "0" ]; then
    /sbin/service arpwatch stop > /dev/null 2>&1
    /sbin/chkconfig --del arpwatch
fi
exit 0

%post -n libpcap -p /sbin/ldconfig

%postun -n libpcap -p /sbin/ldconfig

%files
%defattr(-, root, root)
%doc %{tcpdump_dir}/{CHANGES,FILES,INSTALL,README,VERSION}
%{_sbindir}/tcpdump
%{_sbindir}/tcpslice
%{_mandir}/man8/tcpdump.8*
%{_mandir}/man8/tcpslice.8*

%files -n libpcap
%defattr(-, root, root)
%doc %{libpcap_dir}/{CHANGES,FILES,README,VERSION}
%{_includedir}/pcap*
%{_libdir}/libpcap.*
%{_mandir}/man3/pcap.3*

%files -n arpwatch
%defattr(-,root,root)
%doc %{arpwatch_dir}/{README,CHANGES}
%{_sbindir}/arpwatch
%{_sbindir}/arpsnmp
%{_mandir}/man8/arpwatch.8*
%{_mandir}/man8/arpsnmp.8*
%config /etc/rc.d/init.d/arpwatch
%config(noreplace) %{_sysconfdir}/sysconfig/arpwatch
%defattr(-,pcap,pcap)
%verify(not md5 size mtime) %config(noreplace) %{_vararpwatch}/arp.dat
%verify(not md5 size mtime) %config %{_vararpwatch}/ethercodes.dat
%config %{_vararpwatch}/missingcodes.txt
%{_vararpwatch}/*.awk
%{_vararpwatch}/arp2ethers
%{_vararpwatch}/arpfetch
%{_vararpwatch}/massagevendor
%{_vararpwatch}/massagevendor-old

%changelog
* Thu Jun  8 2006 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.9.4-2m)
- delete %%{_includedir}/net from files list

* Fri May  5 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (3.9.4-1m)
- update 3.9.4
- [SECURITY] CVE-2005-1280 CVE-2005-1279 CVE-2005-1278 CVE-2005-1267
- sync FC

* Tue Feb  1 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (3.8.3-5m)
- enable x86_64.

* Mon Oct 25 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (3.8.3-4m)
- add gcc34 patch

* Tue Jul 13 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.8.3-3m)
- delete %%define _ipv6		1
- add BuildRequires: momonga-rpmmacros >= 20040310-6m

* Sat Apr 10 2004 Toru Hoshina <t@momonga-linux.org>
- (3.8.3-2m)
- The release number is applied for all of sub packages, however all packages
  aren't always updated at the same time, so we need independent release
  number for each sub package, otherwise must use epoch...

* Wed Apr 7 2004 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (3.8.3-1m)
- update tcpdump to 3.8.3
- update libpcap to 0.8.3
- includes security fix. old patches are commented out.

* Thu Apr  1 2004 zunda <zunda at freeshell.org>
- (3.7.2-4m)
- arpwatch updated from 2.1a11 to 2.1a13

* Sun Jul 20 2003 Kazuhiko <kazuhiko@fdiary.net>
- (3.7.2-3m)
- rebuild against glibc-2.3.2                               

* Thu May  8 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.7.2-2m)
- fix include order in print-sctp.c
- remove INSTALL from %%files libpcap

* Mon Mar 10 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (3.7.2-1m)
  update to tcpdump 3.7.2 and libpcap 0.7.2

* Mon Mar 10 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (3.6.2-21m)
  rebuild against openssl 0.9.7a

* Thu Jun  6 2002 Tsutomu Yasuda <tom@kondara.org>
- (3.6.2-20k)
  security fix. http://online.securityfocus.com/bid/4890
  
* Fri May 17 2002 YAMAZAKI Makoto <zaki@kondara.org>
- (3.6.2-18k)
- rebuild against glibc-2.2.5-12k

* Wed May 15 2002 YAMAZAKI Makoto <zaki@kondara.org>
- (3.6.2-16k)
- remove Patch1(libpcap-0.6.2-ifaddrs.patch)

* Tue May 14 2002 Toru Hoshina <t@kondara.org>
- (3.6.2-14k)
- security fix. jitterbug/1055
- ipv6 enabled at this time, but getifaddrs doesn't work, FIXME...

* Mon Feb 18 2002 Tsutomu Yasuda <tom@kondara.org>
- (3.6.2-10k)
- arpwatch update to 2.1a11

* Sat Apr 14 2001 Toru Hoshina <toru@df-usa.com>
- rebuild against openssl 0.9.6.

* Fri Apr 13 2001 Shingo Akagaki <dora@kondara.org>
- /etc/rc.d/init.d -> /etc/init.d

* Tue Mar  6 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.6.2-4k)
- errase IPv6 function with %{_ipv6} macro

* Fri Feb  9 2001 Kusunoki Masanori <nori@kondara.org>
- (3.6.2-3k)
- update to 3.6.2
- update libpcap to 0.6.2

* Sat Feb  3 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.6.1-7k)
- build against rpm-3.0.5-39k

* Thu Feb  1 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.6.1-5k)
- modified %files section

* Wed Jan 31 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.6.1-3k)
- update to 3.6.1
- update libpcap to 0.6.1

* Tue Nov 28 2000 Kenichi Matsubara <m@kondara.org>
- /etc/rc.d/init.d to %_initscriptdir}

* Fri Oct 20 2000 MATSUDA, Daiki <dyky@df-usa.com>
- update arpwatch 2.1a10
- modified spec file a little with macro

* Wed Jul 06 2000 Toru Hoshina <t@kondara.org>
- rebuild against glibc-2.1.90, X-4.0, rpm-3.0.5.

* Wed Mar 1 2000 Masako Hattori <maru@kondara.org>
- change jman mv->cp

* Wed Feb 23 2000 Masako Hattori <maru@kondara.org>
- do not shake %{_mandir}/ja

* Sat Feb 19 2000 Tsutomu Yasuda <tom@kondara.org>
- bug fix libpcap

* Tue Feb 1 2000 Masako Hattori <maru@kondara.org>
- update man-pages-ja-tcpdump-20000115

* Mon Jan 17 2000 Takaaki Tabuchi <tab@kondara.org>
- be able to rebuild non-root user.

* Sat Jan  8 2000 Kazuaki Yoshida <kazuaki@nifty.co.jp>
- 1st Release for "Kondara MNU/Linux".

* Tue Nov 30 1999 Masako Hattori <maru@kondara.org>
- add man-pages-ja-tcpdump-19991115
